(write-line "TXTIN by Phil Kreiker (303) 669-2681")

(defun strip (aline / i j tempstr t)  
  (setq i 1)
  (setq j (strlen aline))
  (setq tempstr "")
  (while (<= i j)
    (setq t (logand 127 (ascii (substr aline i 1))))
    (if (= t 31) (setq t 45))
    (if (>= t 32) (setq tempstr (strcat tempstr (chr t))))
    (setq i (1+ i)))
  tempstr)

(defun realstr (x)
  (rtos x (getvar "lunits") (getvar "luprec")))

(defun angstr (x)
  (angtos x (getvar "aunits") (getvar "auprec")))

(defun C:TXTIN ( / s j p h a f ws)
  (if (not txtstl) (setq txtstl "STANDARD"))
  (setq s (getstring (strcat "Style name <" txtstl ">: ")))
  (if (/= s "") (setq txtstl s))

  (if (not txtjst) (setq txtjst "L"))
  (setq j (getstring (strcat "Justification <" txtjst ">: ")))
  (setq j (substr j 1 1))
  (if (/= j "") (setq txtjst j))
  (if (= txtjst "l") (setq txtjst "L"))

  (graphscr)
  (if (not txtpnt) (setq txtpnt (getvar "lastpoint")))
  (setq p (getpoint "Insertion point:  "))
  (if p (setq txtpnt p))

  (setq txtht (getvar "textsize"))
  (setq h (getdist txtpnt (strcat "Hight <" (realstr txtht) ">:  ")))
  (if h (setq txtht h))
  (if (not txtang) (setq txtang 0.0))
  (setq a (getangle txtpnt (strcat "Angle <" (angstr txtang) ">:  ")))
  (if a (setq txtang a))

  (setq txtfile (getstring "File name:  "))

  (if (/= txtfile "")
      (progn
        (setq ws (getstring "Wordstar Document <N>?  "))
        (setq ws (substr ws 1 1))
        (if (= ws "y") (setq ws "Y"))
        (setq f (open txtfile "r"))
        (if f
          (progn  
            (setq bm (getvar "blipmode"))
            (setvar "blipmode" 0)
            (setq ce (getvar "cmdecho"))
            (setvar "cmdecho" 1)

            (setq lh (/ (* txtht 36.0) 21.0))
            (setq la (- txtang (/ pi 2)))
            (setq ta (/ (* txtang 180.0) pi))

            (setq l (read-line f))
            (if (= ws "Y") (setq l (strip l)))
            (if (= txtjst "L")
              (command "text" "S" txtstl txtpnt txtht ta l)
              (command "text" "S" txtstl txtjst txtpnt txtht ta l))
            (setq txtpnt (polar txtpnt la lh))
            (while (setq l (read-line f))
              (if (= ws "Y") (setq l (strip l)))
              (if (= txtjst "L") 
                (command "text" "S" txtstl txtpnt txtht ta l)
                (command "text" "S" txtstl txtjst txtpnt txtht ta l))
              (setq txtpnt (polar txtpnt la lh)))
          (setvar "blipmode" bm)
          (setvar "cmdecho" ce)))))
(prompt "Command: "))

    
